unit EGUnit;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  EasyGraph, ComCtrls, StdCtrls, ExtCtrls,ShellAPI;

type
  TForm1 = class(TForm)
    EasyGraph1: TEasyGraph;
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    Label4: TLabel;
    ComboBox1: TComboBox;
    Label5: TLabel;
    Label6: TLabel;
    ComboBox2: TComboBox;
    Label7: TLabel;
    Label8: TLabel;
    Edit1: TEdit;
    TabSheet2: TTabSheet;
    Label9: TLabel;
    Label10: TLabel;
    ComboBox3: TComboBox;
    Label11: TLabel;
    ComboBox4: TComboBox;
    ComboBox5: TComboBox;
    Label12: TLabel;
    Label13: TLabel;
    ComboBox6: TComboBox;
    Label14: TLabel;
    Bevel1: TBevel;
    ComboBox7: TComboBox;
    Label15: TLabel;
    ComboBox8: TComboBox;
    Label16: TLabel;
    Edit2: TEdit;
    TabSheet3: TTabSheet;
    Label17: TLabel;
    Label18: TLabel;
    Label20: TLabel;
    Button1: TButton;
    GroupBox1: TGroupBox;
    Label21: TLabel;
    Label22: TLabel;
    ComboBox10: TComboBox;
    Label24: TLabel;
    Button2: TButton;
    Button3: TButton;
    Label25: TLabel;
    TabSheet4: TTabSheet;
    Label27: TLabel;
    Label28: TLabel;
    Label29: TLabel;
    Label31: TLabel;
    CheckBox1: TCheckBox;
    EGLegendList1: TEGLegendList;
    Label1: TLabel;
    ComboBox9: TComboBox;
    Label2: TLabel;
    ComboBox11: TComboBox;
    Label3: TLabel;
    Button4: TButton;
    TabSheet5: TTabSheet;
    Label19: TLabel;
    Label23: TLabel;
    Label26: TLabel;
    Label30: TLabel;
    Label32: TLabel;
    Label33: TLabel;
    Label34: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure ComboBox1Change(Sender: TObject);
    procedure ComboBox2Change(Sender: TObject);
    procedure ComboBox3Change(Sender: TObject);
    procedure ComboBox4Change(Sender: TObject);
    procedure ComboBox5Change(Sender: TObject);
    procedure ComboBox6Change(Sender: TObject);
    procedure Edit1Change(Sender: TObject);
    procedure ComboBox7Change(Sender: TObject);
    procedure Edit2Change(Sender: TObject);
    procedure ComboBox8Change(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure ComboBox10Change(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Label27Click(Sender: TObject);
    procedure Label31Click(Sender: TObject);
    procedure CheckBox1Click(Sender: TObject);
    procedure EGLegendList1Click(Sender: TObject);
    procedure ComboBox9Change(Sender: TObject);
    procedure ComboBox11Change(Sender: TObject);
    procedure Button4Click(Sender: TObject);
  private
    { Private declarations }
    Updating:Boolean;
  public
    { Public declarations }
    function ChangeMouseAction (I:Integer):String;
    procedure GenPoints (X:Integer);
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.GenPoints (X:Integer);
var R,R2,R3:Extended;
    A,B:Integer;
    Rt:TRect2D;
begin
  EasyGraph1.Series.BeginUpdate;
  EasyGraph1.Series[X].Clear;
  A:=Random (1000)+200;
  Rt:=EasyGraph1.VisRect;
  R:=(Rt.X2-Rt.X1)/A;
  R2:=Rt.X1;
  R3:=0.5;
  For B:=1 to A do
  begin
    R3:=R3+(Random-0.5)/10;
    EasyGraph1.Series[X].Add (R2,Rt.Y1+(R3*(Rt.Y2-Rt.Y1)));
    R2:=R2+R;
  end;
  EasyGraph1.Series.EndUpdate;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  Randomize;
  ComboBox1.ItemIndex:=1;
  ComboBox1Change (Self);
  ComboBox2.ItemIndex:=1;
  ComboBox2Change (Self);
  ComboBox9.ItemIndex:=2;
  ComboBox9Change (Self);
  ComboBox3.ItemIndex:=0;
  ComboBox4.ItemIndex:=3;
  ComboBox5.ItemIndex:=0;
  ComboBox6.ItemIndex:=0;
  ComboBox7.ItemIndex:=6;
  ComboBox8.ItemIndex:=0;
  ComboBox11.ItemIndex:=0;
  EasyGraph1.VisRect:=Rect2D (-10,-10,10,10);
  EasyGraph1.Series.Add;
  EasyGraph1.Series[0].Func:='sin (x/2)*2';
  EasyGraph1.Series.Add;
  EasyGraph1.Series[1].Func:='x*x';
  EasyGraph1.Series[1].Color:=clGreen;
  EasyGraph1.Series[1].DrawStyle:=dsPoints;
  EasyGraph1.Series.Add;
  GenPoints (2);
  EasyGraph1.Series[2].Color:=clYellow;
{  EasyGraph1.Series[2].PointSymbol := 'A';}
  PageControl1.ActivePage:=TabSheet5;
  Updating:=False;
  EasyGraph1.BgImage:=ExtractFilePath (Application.ExeName)+'example.bmp';
end;

function TForm1.ChangeMouseAction (I:Integer):String;
begin
  Case I of
    0:Result:='You cannot do this action';
    1:Result:='Use right mouse button';
    2:Result:='Use Shift and left mouse button';
    3:Result:='Use Ctrl and left mouse button';
    4:Result:='Use Alt and left mouse button';
  end;
end;

procedure TForm1.ComboBox1Change(Sender: TObject);
begin
  Label6.Caption:=ChangeMouseAction (ComboBox1.ItemIndex);
  EasyGraph1.MouseZoom:=TMouseAction(ComboBox1.ItemIndex);
end;

procedure TForm1.ComboBox2Change(Sender: TObject);
begin
  Label7.Caption:=ChangeMouseAction (ComboBox2.ItemIndex);
  EasyGraph1.MousePan:=TMouseAction(ComboBox2.ItemIndex);
end;

procedure TForm1.ComboBox3Change(Sender: TObject);
begin
  EasyGraph1.BorderStyle:=TBorderStyle(ComboBox3.ItemIndex);
end;

procedure TForm1.ComboBox4Change(Sender: TObject);
begin
  EasyGraph1.GraphBorder:=TBorderStyle(ComboBox4.ItemIndex);
end;

procedure TForm1.ComboBox5Change(Sender: TObject);
begin
  EasyGraph1.NumbVert:=(ComboBox5.ItemIndex=0);
end;

procedure TForm1.ComboBox6Change(Sender: TObject);
begin
  EasyGraph1.NumbHoriz:=(ComboBox6.ItemIndex=0);
end;

procedure TForm1.Edit1Change(Sender: TObject);
begin
  try
    EasyGraph1.ZoomTime:=StrToInt(Edit1.Text);
  except
  end;
end;

procedure TForm1.ComboBox7Change(Sender: TObject);
begin
  EasyGraph1.GridStyle:=TGridStyle(ComboBox7.ItemIndex);
end;

procedure TForm1.Edit2Change(Sender: TObject);
begin
  try
    EasyGraph1.AspectRatio:=StrToFloat (Edit2.Text);
  except
  end;
end;

procedure TForm1.ComboBox8Change(Sender: TObject);
begin
  EasyGraph1.MaintainRatio:=(ComboBox8.ItemIndex=0);
end;


procedure TForm1.Button1Click(Sender: TObject);
begin
  EasyGraph1.Series.Add;
  EasyGraph1.Series[EasyGraph1.Series.Count-1].Color:=Random ($1000000);
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  GenPoints (EGLegendList1.ItemIndex);
end;

procedure TForm1.ComboBox10Change(Sender: TObject);
begin
  If not Updating then
    EasyGraph1.Series[EGLegendList1.ItemIndex].DrawStyle:=TDrawStyle(ComboBox10.ItemIndex);
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
  If EGLegendList1.ItemIndex>-1 then
  begin
    EasyGraph1.Series.Delete (EGLegendList1.ItemIndex);
  end;
end;

procedure TForm1.Label27Click(Sender: TObject);
begin
  ShellExecute(Form1.Handle, nil, PChar('mailto:vkovalcik@iname.com'),'','',SW_SHOW);
end;

procedure TForm1.Label31Click(Sender: TObject);
begin
  ShellExecute(Form1.Handle, nil, PChar('http://www.geocities.com/SiliconValley/Hills/1335/'),'','',SW_SHOW);
end;


procedure TForm1.CheckBox1Click(Sender: TObject);
begin
  If not Updating then
    EasyGraph1.Series[EGLegendList1.ItemIndex].Visible:=CheckBox1.Checked;
end;

procedure TForm1.EGLegendList1Click(Sender: TObject);
begin
  Updating:=True;
  If EGLegendList1.ItemIndex<0 then
  begin
    Button2.Enabled:=False;
    Button3.Enabled:=False;
    ComboBox10.Enabled:=False;
    Button4.Enabled:=False;
    CheckBox1.Enabled:=False;
  end
  else
  begin
    Button2.Enabled:=True;
    Button3.Enabled:=True;
    ComboBox10.Enabled:=True;
    Button4.Enabled:=True;
    CheckBox1.Enabled:=True;
    Label22.Caption:='Color = '+ColorToString (EasyGraph1.Series[EGLegendList1.ItemIndex].Color);
    If EasyGraph1.Series[EGLegendList1.ItemIndex].DrawStyle=dsLines then
      ComboBox10.ItemIndex:=0
    else
      ComboBox10.ItemIndex:=1;
    CheckBox1.Checked:=EasyGraph1.Series[EGLegendList1.ItemIndex].Visible;
  end;
  Updating:=False;
end;

procedure TForm1.ComboBox9Change(Sender: TObject);
begin
  Label2.Caption:=ChangeMouseAction (ComboBox9.ItemIndex);
  EasyGraph1.MouseFuncHint:=TMouseAction(ComboBox9.ItemIndex);
end;

procedure TForm1.ComboBox11Change(Sender: TObject);
begin
  EasyGraph1.BgStyle:=TBgStyle(ComboBox11.ItemIndex);
end;

procedure TForm1.Button4Click(Sender: TObject);
var S:String;
begin
  S:=EasyGraph1.Series[EGLegendList1.ItemIndex].Func;
  if InputQuery ('Enter Function','Equation:',S) then
  begin
    EasyGraph1.Series[EGLegendList1.ItemIndex].Func:=S;
  end;
end;

end.
